String::RewritePrefix(3)

NAME
String::RewritePrefix - rewrite strings based on a set of known prefixes

VERSION
version 0.009

SYNOPSIS
  use String::RewritePrefix;
  my @to_load = String::RewritePrefix->rewrite(
    { '' => 'MyApp::', '+' => '' },
    qw(Plugin Mixin Addon +Corporate::Thinger),
  );

  # now you have:
  qw(MyApp::Plugin MyApp::Mixin MyApp::Addon Corporate::Thinger)

You can also import a rewrite routine:

  use String::RewritePrefix rewrite => {
    -as => 'rewrite_dt_prefix',
    prefixes => { '' => 'MyApp::', '+' => '' },
  };

  my @to_load = rewrite_dt_prefix( qw(Plugin Mixin Addon +Corporate::Thinger));

  # now you have:
  qw(MyApp::Plugin MyApp::Mixin MyApp::Addon Corporate::Thinger)

PERL VERSION
This module should work on any version of perl still receiving updates from the Perl 5 Porters. This means it should work on any version of perl released in the last two to three years. (That is, if the most recently released version is v5.40, then this module should work on both v5.40 and v5.38.)

Although it may work on older versions of perl, no guarantee is made that the minimum required version will not be increased. The version may be increased for any reason, and there is no promise that patches will be accepted to lower the minimum required perl.

METHODS

  rewrite
  String::RewritePrefix->rewrite(\%prefix, @strings);

This rewrites all the given strings using the rules in %prefix. Its keys are known prefixes for which its values will be substituted. This is performed in longest-first order, and only one prefix will be rewritten.

If the prefix value is a coderef, it will be executed with the remaining string as its only argument. The return value will be used as the prefix.

AUTHOR
Ricardo Signes <cpan@semiotic.systems>

CONTRIBUTORS

•   Florian Ragwitz <rafl@debian.org>

•   Olivier Mengué <dolmen@cpan.org>

•   Ricardo Signes <rjbs@semiotic.systems>

COPYRIGHT AND LICENSE
This software is copyright (c) 2022 by Ricardo Signes.

This is free software; you can redistribute it and/or modify it under the same terms as the Perl 5 programming language system itself.